/* int^WSortedIntSeti\[Xj*/

#include <stdio.h>
#include <stdlib.h>
#include "SortedIntSet.h"

/*--- W̏ ---*/
int Initialize(SortedIntSet *s, int max)
{
	s->num = 0;
	if ((s->set = calloc(max, sizeof(int))) == NULL) {
		s->max = 0;								/* z̊mۂɎs */
		return -1;
	}
	s->max = max;
	return 0;
}

/*--- Wsn̈ʒuTiĂȂȂꍇ͑}|CgTj ---*/
int _search(const SortedIntSet *s, int n, int *flag)
{
	int pl = 0;				/* T͈͐擪̓Y */
	int pr = s->num - 1;	/* @ V @̓Y */
	int pc;					/* @ V @̓Y */

	*flag = 1;
	if (s->num <= 0) return 0;		/* W */
	
	do {
		pc = (pl + pr) / 2;
		if (s->set[pc] == n) {		/* T */
			*flag = 0;
			return pc;
		} else if (s->set[pc] < n)
			pl = pc + 1;
		else
			pr = pc - 1;
	} while (pl <= pr);

	return pl;						/* Ts */
}

/*--- WsnĂ邩 ---*/
int IsMember(const SortedIntSet *s, int n)
{
	int flag;
	int idx = _search(s, n, &flag);
	return flag ? idx : -1;
}

/*--- Ws͖tivfǉłȂԁj ---*/
int IsFull(const SortedIntSet *s)
{
	return s->num >= s->max;
}

/*--- Wsnǉ ---*/
void Add(SortedIntSet *s, int n)
{
	int i, idx, flag;

	if (s->num < s->max) {
		idx = _search(s, n, &flag);
		if (flag == 1) {						/* ܂܂Ȃ */
			s->num++;
			for (i = s->num - 1; i > idx; i--)
				s->set[i] = s->set[i - 1];
			s->set[idx] = n;					/* set[idx]ɑ} */
		}
	}
}

/*--- Wsn폜 ---*/
void Remove(SortedIntSet *s, int n)
{
	int i, idx, flag;

	if (s->num > 0) {
		idx = _search(s, n, &flag);
		if (flag == 0) {						/* ܂܂Ă */
			--s->num;
			for (i = idx; i < s->num; i++)		/* set[idx]폜 */
				s->set[i] = s->set[i + 1];		/* ȍ~̗vf炷 */
		}
	}
}

/*--- Wsi[łő̗vf ---*/
int Capacity(const SortedIntSet *s)
{
	return s->max;
}

/*--- Ws̗vf ---*/
int Size(const SortedIntSet *s)
{
	return s->num;
}

/*--- Ws2s1ɑ ---*/
void Assign(SortedIntSet *s1, const SortedIntSet *s2)
{
	int i;
	int n = (s1->max < s2->num) ? s1->max : s2->num;	/* Rs[vf */

	for (i = 0; i < n; i++)
		s1->set[i] = s2->set[i];
	s1->num = n;
}

/*--- Ws1s2͓ ---*/
int Equal(const SortedIntSet *s1, const SortedIntSet *s2)
{
	int i;

	if (Size(s1) != Size(s2))
		return 0;

	for (i = 0; i < s1->num; i++)
		if (s1->set[i] != s2->set[i])
			return 0;
	return 1;
}

/*--- Ws2s3̘aWs1ɑ ---*/
SortedIntSet *Union(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3)
{
	int k2, k3;

	s1->num = 0;
	k2 = k3 = 0;
	while (k2 < s2->num && k3 < s3->num) {
		if (s2->set[k2] < s3->set[k3])
			s1->set[s1->num++] = s2->set[k2++];
		else if (s2->set[k2] > s3->set[k3])
			s1->set[s1->num++] = s3->set[k3++];
		else {
			s1->set[s1->num++] = s2->set[k2++];
			k3++;
		}
		if (s1->num == s1->max) return s1;
	}

	if (k2 < s2->num)
		while (k2 < s2->num  &&  s1->num < s1->max)
			s1->set[s1->num++] = s2->set[k2++];
	else
		while (k3 < s3->num  &&  s1->num < s1->max)
			s1->set[s1->num++] = s3->set[k3++];

	return s1;
}

/*--- Ws2s3̐ϏWs1ɑ ---*/
SortedIntSet *Intersection(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3)
{
	int k2, k3;

	s1->num = 0;
	k2 = k3 = 0;
	while (k2 < s2->num && k3 < s3->num) {
		 if (s2->set[k2] < s3->set[k3])
			k2++;
		else if (s2->set[k2] > s3->set[k3])
			k3++;
		else {
			s1->set[s1->num++] = s2->set[k2];
			k3++;
			if (s1->num == s1->max)
				return s1;
		}
	}
	return s1;
}

/*--- Ws2s3Ws1ɑ ---*/
SortedIntSet *Difference(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3)
{
	int k2, k3;

	s1->num = 0;
	k2 = k3 = 0;
	while (k2 < s2->num && k3 < s3->num) {
		if (s2->set[k2] < s3->set[k3])
			s1->set[s1->num++] = s2->set[k2++];
		else if (s2->set[k2] > s3->set[k3])
			k3++;
		else {
			k2++;
			k3++;
		}
		if (s1->num == s1->max) return s1;
	}

	if (k2 < s2->num)
		while (k2 < s2->num  &&  s1->num < s1->max)
			s1->set[s1->num++] = s2->set[k2++];
	return s1;
}

/*--- Ws2s3̑Ώۍs1ɑ ---*/
SortedIntSet *SymmetricDifference(SortedIntSet *s1, const SortedIntSet *s2, const SortedIntSet *s3)
{
	int k2, k3;

	s1->num = 0;
	k2 = k3 = 0;
	while (k2 < s2->num && k3 < s3->num) {
		if (s2->set[k2] < s3->set[k3])
			s1->set[s1->num++] = s2->set[k2++];
		else if (s2->set[k2] > s3->set[k3])
			s1->set[s1->num++] = s3->set[k3++];
		else {
			k2++;
			k3++;
		}
		if (s1->num == s1->max) return s1;
	}

	if (k2 < s2->num)
		while (k2 < s2->num && s1->num < s1->max)
			s1->set[s1->num++] = s2->set[k2++];
	else
		while (k3 < s3->num && s1->num < s1->max)
			s1->set[s1->num++] = s3->set[k3++];

	return s1;
}

/*--- Ws1ɑ΂ďWs2̑Svfǉ ---*/
SortedIntSet *ToUnion(SortedIntSet *s1, const SortedIntSet *s2)
{
	int i;

	for (i = 0; i < s2->num; i++)
		Add(s1, s2->set[i]);

	return s1;
}

/*--- Ws1Ws2Ɋ܂܂ȂSvf폜 ---*/
SortedIntSet *ToIntersection(SortedIntSet *s1, const SortedIntSet *s2)
{
	int i = 0;

	while (i < s1->num) {
		if (IsMember(s2, s1->set[i]) == -1)
			Remove(s1, s1->set[i]);
		else
			i++;
	}
	return s1;
}

/*--- Ws1Ws2Ɋ܂܂Svf폜 ---*/
SortedIntSet *ToDifference(SortedIntSet *s1, const SortedIntSet *s2)
{
	int i;

	for (i = 0; i < s2->num; i++)
		Remove(s1, s2->set[i]);

	return s1;
}

/*--- Ws1s2̕W ---*/
int IsSubset(const SortedIntSet *s1, const SortedIntSet *s2)
{
	int i, j;

	for (i = 0; i < s1->num; i++) {
		for (j = 0; j < s2->num; j++)
			if (s1->set[i] == s2->set[j])
				break;
		if (j == s2->num)					/* s1->set[i]s2Ɋ܂܂Ȃ */
			return 0;
	}
	return 1;
}

/*--- Ws1s2̐^W ---*/
int IsProperSubset(const SortedIntSet *s1, const SortedIntSet *s2)
{
	int i;

	if (s1->num >= s2->num)					/* s1̗vfs2ȏł */
		return 0;							/* s1s2̐^Wł͂Ȃ */

	return IsSubset(s1, s2);
}

/*--- Ws̑Svf\ ---*/
void Print(const SortedIntSet *s)
{
	int i;

	printf("{ ");
	for (i = 0; i < s->num; i++)
		printf("%d ", s->set[i]);
	printf("}");
}

/*--- Ws̑Svf\istj---*/
void PrintLn(const SortedIntSet *s)
{
	Print(s);
	putchar('\n');
}

/*--- Ws̑Svf폜 ---*/
void Clear(SortedIntSet *s)
{
	s->num = 0;
}

/*--- W̌n ---*/
void Terminate(SortedIntSet *s)
{
	if (s->set != NULL) {
		free(s->set);							/* z */
		s->max = s->num = 0;
	}
}
