/* J[\ɂ`Xgi\[Xj*/

/* ֐PurgeƊ֐RetrieveList9-5ɒǉ */

#include <stdio.h>
#include <stdlib.h>
#include "Member.h"
#include "ArrayLinkedList.h"

/*--- }郌R[h̃CfbNX߂ ---*/
static Index GetIndex(List *list)
{
	if (list->deleted == Null)				/* 폜R[hȂꍇ */
		return ++(list->max);
	else {
		Index rec = list->deleted;
		list->deleted = list->n[rec].Dnext;
		return rec;
	}
}

/*--- w肵R[h폜Xgɓo^ ---*/
static void DeleteIndex(List *list, Index idx)
{
	if (list->deleted == Null) {			/* 폜R[hȂꍇ */
		list->deleted = idx;
		list->n[idx].Dnext = Null;
	} else {
		Index ptr = list->deleted;
		list->deleted = idx;
		list->n[idx].Dnext = ptr;
	}
}

/*--- n̎wm[h̊eoɒlݒ ----*/
static void SetNode(Node *n, const Member *x, Index next)
{
	n->data = *x;							/* f[^ */
	n->next = next;							/* 㑱m[hւ̃|C^ */
}

/*--- `Xgiővfsizej---*/
void Initialize(List *list, int size)
{
	list->n = calloc(size, sizeof(Node));
	list->head = Null;							/* 擪m[h */
	list->crnt = Null;							/* ڃm[h */
	list->max = Null;
	list->deleted = Null;
}

/*--- ֐compareɂxƈvƔ肳m[hT ---*/
Index Search(List *list, const Member *x,
						 int compare(const Member *x, const Member *y))
{
	Index ptr = list->head;

	while (ptr != Null) {
		if (compare(&list->n[ptr].data, x) == 0) {
			list->crnt = ptr;
			return ptr;				/* T */
		}
		ptr = list->n[ptr].next;
	}
	return Null;						/* Ts */
}

/*--- 擪n̃m[hւ̃J[\擾 ---*/
Index Retrieve(List *list, int n)
{
	Index ptr = list->head;

	while (n >= 0  &&  ptr != Null) {
		if (n-- == 0) {
			list->crnt = ptr;
			return ptr;					/* T */
		}
		ptr = list->n[ptr].next;		/* 㑱m[hɒ */
	}
	return Null;	
}

/*--- 擪Ƀm[h} ---*/
void InsertFront(List *list, const Member *x)
{
	Index ptr = list->head;
	list->head = list->crnt = GetIndex(list);
	SetNode(&list->n[list->head], x, ptr);
}

/*--- Ƀm[h} ---*/
void InsertRear(List *list, const Member *x)
{
	if (list->head == Null)					/* ł */
		InsertFront(list, x);				/* 擪ɑ} */
	else {
		Index ptr = list->head;
		while (list->n[ptr].next != Null)
			ptr = list->n[ptr].next;
		list->n[ptr].next = list->crnt = GetIndex(list);
		SetNode(&list->n[list->n[ptr].next], x, Null);
	}
}

/*--- 擪m[h폜 ---*/
void RemoveFront(List *list)
{
	if (list->head != Null) {
		Index ptr = list->n[list->head].next;
		DeleteIndex(list, list->head);
		list->head = list->crnt = ptr;
	}
}

/*--- m[h폜 ---*/
void RemoveRear(List *list)
{
	if (list->head != Null) {
		if (list->n[list->head].next == Null)	/* m[hł */
			RemoveFront(list);					/* 擪m[h폜 */
		else {
			Index ptr = list->head;
			Index pre;

			while (list->n[ptr].next != Null) {
				pre = ptr;
				ptr = list->n[ptr].next;
			}
			list->n[pre].next = Null;
			DeleteIndex(list, ptr);
			list->crnt = pre;
		}
	}
}

/*--- ڃm[h폜 ---*/
void RemoveCurrent(List *list)
{
	if (list->head != Null) {
		if (list->crnt == list->head)		/* 擪m[hɒڂĂ */
			RemoveFront(list);				/* 擪m[h폜 */
		else {
			Index ptr = list->head;

			while (list->n[ptr].next != list->crnt)
				ptr = list->n[ptr].next;
			list->n[ptr].next = list->n[list->crnt].next;
			DeleteIndex(list, list->crnt);
			list->crnt = ptr;
		}
	}
}

/*--- Sm[h폜 ---*/
void Clear(List *list)
{
	while (list->head != Null)			/* ɂȂ܂ */
		RemoveFront(list);				/* 擪m[h폜 */
	list->crnt = Null;
}

/*--- r֐ɂēƂ݂Ȃm[h폜 ---*/
void Purge(List *list, int compare(const Member *x, const Member *y))
{
	Index ptr = list->head;

	while (ptr != Null) {
		Index ptr2 = ptr;
		Index pre = ptr;

		while (list->n[ptr2].next != Null) {
			ptr2 = list->n[pre].next;
			if (!compare(&list->n[ptr].data, &list->n[ptr2].data)) {
				list->n[pre].next = list->n[ptr2].next;
				DeleteIndex(list, ptr2);
			} else {
				pre = ptr2;
			}
		}
		ptr = list->n[ptr].next;
	}
	list->crnt = list->head;
}

/*--- ڃm[h̃f[^\ ---*/
void PrintCurrent(const List *list)
{
	if (list->crnt == Null)
		printf("ڗvf͂܂B");
	else
		PrintMember(&list->n[list->crnt].data);
}

/*--- ڃm[h̃f[^\istj---*/
void PrintLnCurrent(const List *list)
{
	PrintCurrent(list);
	putchar('\n');
}

/*--- Sm[h̃f[^\ ---*/
void Print(const List *list)
{
	if (list->head == Null)
		puts("m[h܂B");
	else {
		Index ptr = list->head;

		puts("yꗗ\z");
		while (ptr != Null) {
			PrintLnMember(&list->n[ptr].data);
			ptr = list->n[ptr].next;		/* 㑱m[h */
		}
	}
}

/*--- `Xǧn ---*/
void Terminate(List *list)
{
	Clear(list);					/* Sm[h폜 */
	free(list->n);
}
